'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getOwnPropertyNames = require('babel-runtime/core-js/object/get-own-property-names');

var _getOwnPropertyNames2 = _interopRequireDefault(_getOwnPropertyNames);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsPromise = require('fs-promise');

var _fs = require('fs');

var _babelCore = require('babel-core');

var _mkdirpThen = require('mkdirp-then');

var _mkdirpThen2 = _interopRequireDefault(_mkdirpThen);

var _broccoliPlugin = require('broccoli-plugin');

var _broccoliPlugin2 = _interopRequireDefault(_broccoliPlugin);

var _walkSync = require('walk-sync');

var _walkSync2 = _interopRequireDefault(_walkSync);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Broccoli plugin that transpiles es2015 code to es5 using Babel of version 6.
 */

var Babel = function (_Plugin) {
  (0, _inherits3.default)(Babel, _Plugin);


  /**
   * Creates a new Babel plugin instance. For more info see
   * {@link https://github.com/broccolijs/broccoli-plugin}
   *
   * @param {Node|Node[]} inputNodes List of input nodes
   * @param {Object} options Plugin options
   */

  function Babel(inputNodes) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    (0, _classCallCheck3.default)(this, Babel);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Babel).call(this, Array.isArray(inputNodes) ? inputNodes : [inputNodes], {
      name: 'Babel',
      annotation: options.annotation,
      persistentOutput: options.persistentOutput ? options.persistentOutput : false
    }));

    delete options.annotation;
    delete options.persistentOutput;

    if ((0, _getOwnPropertyNames2.default)(options).length === 0) {
      options = JSON.parse((0, _fs.readFileSync)(_path2.default.join(process.cwd(), '.babelrc'), 'utf8'));
    }

    /**
     * Plugin options. Equal to Babel options
     * {@link https://babeljs.io/docs/usage/options/}
     *
     * @type {Object}
     */
    _this.options = options;
    return _this;
  }

  /**
   * Builds received nodes.
   *
   * Walks over all files in the directory, asynchronously reads it, compiles
   * through babel and writes the compiled data to the output folder.
   */


  (0, _createClass3.default)(Babel, [{
    key: 'build',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var _inputPaths, inputPath, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, fname, code, output, outputFilename;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _inputPaths = (0, _slicedToArray3.default)(this.inputPaths, 1);
                inputPath = _inputPaths[0];
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 5;
                _iterator = (0, _getIterator3.default)((0, _walkSync2.default)(inputPath));

              case 7:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 23;
                  break;
                }

                fname = _step.value;

                if (!(fname.slice(-3) !== '.js')) {
                  _context.next = 11;
                  break;
                }

                return _context.abrupt('continue', 20);

              case 11:
                _context.next = 13;
                return (0, _fsPromise.readFile)(inputPath + '/' + fname, 'utf8');

              case 13:
                code = _context.sent;
                output = (0, _babelCore.transform)(code, this.options);
                outputFilename = this.outputPath + '/' + fname;
                _context.next = 18;
                return (0, _mkdirpThen2.default)(_path2.default.dirname(outputFilename));

              case 18:
                _context.next = 20;
                return (0, _fsPromise.writeFile)(outputFilename, output.code);

              case 20:
                _iteratorNormalCompletion = true;
                _context.next = 7;
                break;

              case 23:
                _context.next = 29;
                break;

              case 25:
                _context.prev = 25;
                _context.t0 = _context['catch'](5);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 29:
                _context.prev = 29;
                _context.prev = 30;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 32:
                _context.prev = 32;

                if (!_didIteratorError) {
                  _context.next = 35;
                  break;
                }

                throw _iteratorError;

              case 35:
                return _context.finish(32);

              case 36:
                return _context.finish(29);

              case 37:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[5, 25, 29, 37], [30,, 32, 36]]);
      }));

      function build() {
        return ref.apply(this, arguments);
      }

      return build;
    }()
  }]);
  return Babel;
}(_broccoliPlugin2.default);

exports.default = Babel;
module.exports = exports['default'];